/*
 * Common header file for ESP32 and RV32 sides of link
 */
#ifndef ESPLINK_H
#define ESPLINK_H 1

#include <inttypes.h>
#include <stddef.h>

#define FPGA_HDR_ADDR	0x40000000

#define DRAM_IO_MAGIC	0x3648dec4
struct dram_io_head {
    uint32_t    magic;
    size_t      hlen;
    void       *dptr;
    size_t      dlen;
    struct {
	union {
	    uint32_t    cfg;
	    struct {
		uint8_t fixes;
		uint8_t minor;
		uint8_t major;
		uint8_t fpga;
	    };
	};
    } board;
    const char *signature;
    size_t      signature_len;
    uint32_t    resv[9];
};

#define RV_IRQ_UNDERRUN	0
#define RV_IRQ_HELLO	1
#define ESP_IRQ_READY	1

#endif

